/*
Copyright The Kubernetes Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package v1alpha1

import (
	v1alpha1 "github.com/moiot/gravity/k8s_operator/pkg/apis/cluster/v1alpha1"
	scheme "github.com/moiot/gravity/k8s_operator/pkg/client/cluster/clientset/versioned/scheme"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// DrcClustersGetter has a method to return a DrcClusterInterface.
// A group's client should implement this interface.
type DrcClustersGetter interface {
	DrcClusters(namespace string) DrcClusterInterface
}

// DrcClusterInterface has methods to work with DrcCluster resources.
type DrcClusterInterface interface {
	Create(*v1alpha1.DrcCluster) (*v1alpha1.DrcCluster, error)
	Update(*v1alpha1.DrcCluster) (*v1alpha1.DrcCluster, error)
	UpdateStatus(*v1alpha1.DrcCluster) (*v1alpha1.DrcCluster, error)
	Delete(name string, options *v1.DeleteOptions) error
	DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error
	Get(name string, options v1.GetOptions) (*v1alpha1.DrcCluster, error)
	List(opts v1.ListOptions) (*v1alpha1.DrcClusterList, error)
	Watch(opts v1.ListOptions) (watch.Interface, error)
	Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1alpha1.DrcCluster, err error)
	DrcClusterExpansion
}

// drcClusters implements DrcClusterInterface
type drcClusters struct {
	client rest.Interface
	ns     string
}

// newDrcClusters returns a DrcClusters
func newDrcClusters(c *DrcV1alpha1Client, namespace string) *drcClusters {
	return &drcClusters{
		client: c.RESTClient(),
		ns:     namespace,
	}
}

// Get takes name of the drcCluster, and returns the corresponding drcCluster object, and an error if there is any.
func (c *drcClusters) Get(name string, options v1.GetOptions) (result *v1alpha1.DrcCluster, err error) {
	result = &v1alpha1.DrcCluster{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("drcclusters").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do().
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of DrcClusters that match those selectors.
func (c *drcClusters) List(opts v1.ListOptions) (result *v1alpha1.DrcClusterList, err error) {
	result = &v1alpha1.DrcClusterList{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("drcclusters").
		VersionedParams(&opts, scheme.ParameterCodec).
		Do().
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested drcClusters.
func (c *drcClusters) Watch(opts v1.ListOptions) (watch.Interface, error) {
	opts.Watch = true
	return c.client.Get().
		Namespace(c.ns).
		Resource("drcclusters").
		VersionedParams(&opts, scheme.ParameterCodec).
		Watch()
}

// Create takes the representation of a drcCluster and creates it.  Returns the server's representation of the drcCluster, and an error, if there is any.
func (c *drcClusters) Create(drcCluster *v1alpha1.DrcCluster) (result *v1alpha1.DrcCluster, err error) {
	result = &v1alpha1.DrcCluster{}
	err = c.client.Post().
		Namespace(c.ns).
		Resource("drcclusters").
		Body(drcCluster).
		Do().
		Into(result)
	return
}

// Update takes the representation of a drcCluster and updates it. Returns the server's representation of the drcCluster, and an error, if there is any.
func (c *drcClusters) Update(drcCluster *v1alpha1.DrcCluster) (result *v1alpha1.DrcCluster, err error) {
	result = &v1alpha1.DrcCluster{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("drcclusters").
		Name(drcCluster.Name).
		Body(drcCluster).
		Do().
		Into(result)
	return
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().

func (c *drcClusters) UpdateStatus(drcCluster *v1alpha1.DrcCluster) (result *v1alpha1.DrcCluster, err error) {
	result = &v1alpha1.DrcCluster{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("drcclusters").
		Name(drcCluster.Name).
		SubResource("status").
		Body(drcCluster).
		Do().
		Into(result)
	return
}

// Delete takes name of the drcCluster and deletes it. Returns an error if one occurs.
func (c *drcClusters) Delete(name string, options *v1.DeleteOptions) error {
	return c.client.Delete().
		Namespace(c.ns).
		Resource("drcclusters").
		Name(name).
		Body(options).
		Do().
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *drcClusters) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	return c.client.Delete().
		Namespace(c.ns).
		Resource("drcclusters").
		VersionedParams(&listOptions, scheme.ParameterCodec).
		Body(options).
		Do().
		Error()
}

// Patch applies the patch and returns the patched drcCluster.
func (c *drcClusters) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1alpha1.DrcCluster, err error) {
	result = &v1alpha1.DrcCluster{}
	err = c.client.Patch(pt).
		Namespace(c.ns).
		Resource("drcclusters").
		SubResource(subresources...).
		Name(name).
		Body(data).
		Do().
		Into(result)
	return
}
