/*
Copyright The Kubernetes Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	v1alpha1 "github.com/moiot/gravity/k8s_operator/pkg/apis/cluster/v1alpha1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeDrcClusters implements DrcClusterInterface
type FakeDrcClusters struct {
	Fake *FakeDrcV1alpha1
	ns   string
}

var drcclustersResource = schema.GroupVersionResource{Group: "drc.mobike.io", Version: "v1alpha1", Resource: "drcclusters"}

var drcclustersKind = schema.GroupVersionKind{Group: "drc.mobike.io", Version: "v1alpha1", Kind: "DrcCluster"}

// Get takes name of the drcCluster, and returns the corresponding drcCluster object, and an error if there is any.
func (c *FakeDrcClusters) Get(name string, options v1.GetOptions) (result *v1alpha1.DrcCluster, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(drcclustersResource, c.ns, name), &v1alpha1.DrcCluster{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.DrcCluster), err
}

// List takes label and field selectors, and returns the list of DrcClusters that match those selectors.
func (c *FakeDrcClusters) List(opts v1.ListOptions) (result *v1alpha1.DrcClusterList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(drcclustersResource, drcclustersKind, c.ns, opts), &v1alpha1.DrcClusterList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1alpha1.DrcClusterList{ListMeta: obj.(*v1alpha1.DrcClusterList).ListMeta}
	for _, item := range obj.(*v1alpha1.DrcClusterList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested drcClusters.
func (c *FakeDrcClusters) Watch(opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(drcclustersResource, c.ns, opts))

}

// Create takes the representation of a drcCluster and creates it.  Returns the server's representation of the drcCluster, and an error, if there is any.
func (c *FakeDrcClusters) Create(drcCluster *v1alpha1.DrcCluster) (result *v1alpha1.DrcCluster, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(drcclustersResource, c.ns, drcCluster), &v1alpha1.DrcCluster{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.DrcCluster), err
}

// Update takes the representation of a drcCluster and updates it. Returns the server's representation of the drcCluster, and an error, if there is any.
func (c *FakeDrcClusters) Update(drcCluster *v1alpha1.DrcCluster) (result *v1alpha1.DrcCluster, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(drcclustersResource, c.ns, drcCluster), &v1alpha1.DrcCluster{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.DrcCluster), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeDrcClusters) UpdateStatus(drcCluster *v1alpha1.DrcCluster) (*v1alpha1.DrcCluster, error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateSubresourceAction(drcclustersResource, "status", c.ns, drcCluster), &v1alpha1.DrcCluster{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.DrcCluster), err
}

// Delete takes name of the drcCluster and deletes it. Returns an error if one occurs.
func (c *FakeDrcClusters) Delete(name string, options *v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteAction(drcclustersResource, c.ns, name), &v1alpha1.DrcCluster{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeDrcClusters) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(drcclustersResource, c.ns, listOptions)

	_, err := c.Fake.Invokes(action, &v1alpha1.DrcClusterList{})
	return err
}

// Patch applies the patch and returns the patched drcCluster.
func (c *FakeDrcClusters) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1alpha1.DrcCluster, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(drcclustersResource, c.ns, name, data, subresources...), &v1alpha1.DrcCluster{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.DrcCluster), err
}
