/*
Copyright The Kubernetes Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package v1alpha1

import (
	v1alpha1 "github.com/moiot/gravity/k8s_operator/pkg/apis/pipeline/v1alpha1"
	scheme "github.com/moiot/gravity/k8s_operator/pkg/client/pipeline/clientset/versioned/scheme"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// DrcPipelinesGetter has a method to return a DrcPipelineInterface.
// A group's client should implement this interface.
type DrcPipelinesGetter interface {
	DrcPipelines(namespace string) DrcPipelineInterface
}

// DrcPipelineInterface has methods to work with DrcPipeline resources.
type DrcPipelineInterface interface {
	Create(*v1alpha1.DrcPipeline) (*v1alpha1.DrcPipeline, error)
	Update(*v1alpha1.DrcPipeline) (*v1alpha1.DrcPipeline, error)
	UpdateStatus(*v1alpha1.DrcPipeline) (*v1alpha1.DrcPipeline, error)
	Delete(name string, options *v1.DeleteOptions) error
	DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error
	Get(name string, options v1.GetOptions) (*v1alpha1.DrcPipeline, error)
	List(opts v1.ListOptions) (*v1alpha1.DrcPipelineList, error)
	Watch(opts v1.ListOptions) (watch.Interface, error)
	Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1alpha1.DrcPipeline, err error)
	DrcPipelineExpansion
}

// drcPipelines implements DrcPipelineInterface
type drcPipelines struct {
	client rest.Interface
	ns     string
}

// newDrcPipelines returns a DrcPipelines
func newDrcPipelines(c *DrcV1alpha1Client, namespace string) *drcPipelines {
	return &drcPipelines{
		client: c.RESTClient(),
		ns:     namespace,
	}
}

// Get takes name of the drcPipeline, and returns the corresponding drcPipeline object, and an error if there is any.
func (c *drcPipelines) Get(name string, options v1.GetOptions) (result *v1alpha1.DrcPipeline, err error) {
	result = &v1alpha1.DrcPipeline{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("drcpipelines").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do().
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of DrcPipelines that match those selectors.
func (c *drcPipelines) List(opts v1.ListOptions) (result *v1alpha1.DrcPipelineList, err error) {
	result = &v1alpha1.DrcPipelineList{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("drcpipelines").
		VersionedParams(&opts, scheme.ParameterCodec).
		Do().
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested drcPipelines.
func (c *drcPipelines) Watch(opts v1.ListOptions) (watch.Interface, error) {
	opts.Watch = true
	return c.client.Get().
		Namespace(c.ns).
		Resource("drcpipelines").
		VersionedParams(&opts, scheme.ParameterCodec).
		Watch()
}

// Create takes the representation of a drcPipeline and creates it.  Returns the server's representation of the drcPipeline, and an error, if there is any.
func (c *drcPipelines) Create(drcPipeline *v1alpha1.DrcPipeline) (result *v1alpha1.DrcPipeline, err error) {
	result = &v1alpha1.DrcPipeline{}
	err = c.client.Post().
		Namespace(c.ns).
		Resource("drcpipelines").
		Body(drcPipeline).
		Do().
		Into(result)
	return
}

// Update takes the representation of a drcPipeline and updates it. Returns the server's representation of the drcPipeline, and an error, if there is any.
func (c *drcPipelines) Update(drcPipeline *v1alpha1.DrcPipeline) (result *v1alpha1.DrcPipeline, err error) {
	result = &v1alpha1.DrcPipeline{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("drcpipelines").
		Name(drcPipeline.Name).
		Body(drcPipeline).
		Do().
		Into(result)
	return
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().

func (c *drcPipelines) UpdateStatus(drcPipeline *v1alpha1.DrcPipeline) (result *v1alpha1.DrcPipeline, err error) {
	result = &v1alpha1.DrcPipeline{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("drcpipelines").
		Name(drcPipeline.Name).
		SubResource("status").
		Body(drcPipeline).
		Do().
		Into(result)
	return
}

// Delete takes name of the drcPipeline and deletes it. Returns an error if one occurs.
func (c *drcPipelines) Delete(name string, options *v1.DeleteOptions) error {
	return c.client.Delete().
		Namespace(c.ns).
		Resource("drcpipelines").
		Name(name).
		Body(options).
		Do().
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *drcPipelines) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	return c.client.Delete().
		Namespace(c.ns).
		Resource("drcpipelines").
		VersionedParams(&listOptions, scheme.ParameterCodec).
		Body(options).
		Do().
		Error()
}

// Patch applies the patch and returns the patched drcPipeline.
func (c *drcPipelines) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1alpha1.DrcPipeline, err error) {
	result = &v1alpha1.DrcPipeline{}
	err = c.client.Patch(pt).
		Namespace(c.ns).
		Resource("drcpipelines").
		SubResource(subresources...).
		Name(name).
		Body(data).
		Do().
		Into(result)
	return
}
