/*
Copyright The Kubernetes Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	v1alpha1 "github.com/moiot/gravity/k8s_operator/pkg/apis/pipeline/v1alpha1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeDrcPipelines implements DrcPipelineInterface
type FakeDrcPipelines struct {
	Fake *FakeDrcV1alpha1
	ns   string
}

var drcpipelinesResource = schema.GroupVersionResource{Group: "drc.mobike.io", Version: "v1alpha1", Resource: "drcpipelines"}

var drcpipelinesKind = schema.GroupVersionKind{Group: "drc.mobike.io", Version: "v1alpha1", Kind: "DrcPipeline"}

// Get takes name of the drcPipeline, and returns the corresponding drcPipeline object, and an error if there is any.
func (c *FakeDrcPipelines) Get(name string, options v1.GetOptions) (result *v1alpha1.DrcPipeline, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(drcpipelinesResource, c.ns, name), &v1alpha1.DrcPipeline{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.DrcPipeline), err
}

// List takes label and field selectors, and returns the list of DrcPipelines that match those selectors.
func (c *FakeDrcPipelines) List(opts v1.ListOptions) (result *v1alpha1.DrcPipelineList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(drcpipelinesResource, drcpipelinesKind, c.ns, opts), &v1alpha1.DrcPipelineList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1alpha1.DrcPipelineList{ListMeta: obj.(*v1alpha1.DrcPipelineList).ListMeta}
	for _, item := range obj.(*v1alpha1.DrcPipelineList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested drcPipelines.
func (c *FakeDrcPipelines) Watch(opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(drcpipelinesResource, c.ns, opts))

}

// Create takes the representation of a drcPipeline and creates it.  Returns the server's representation of the drcPipeline, and an error, if there is any.
func (c *FakeDrcPipelines) Create(drcPipeline *v1alpha1.DrcPipeline) (result *v1alpha1.DrcPipeline, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(drcpipelinesResource, c.ns, drcPipeline), &v1alpha1.DrcPipeline{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.DrcPipeline), err
}

// Update takes the representation of a drcPipeline and updates it. Returns the server's representation of the drcPipeline, and an error, if there is any.
func (c *FakeDrcPipelines) Update(drcPipeline *v1alpha1.DrcPipeline) (result *v1alpha1.DrcPipeline, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(drcpipelinesResource, c.ns, drcPipeline), &v1alpha1.DrcPipeline{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.DrcPipeline), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeDrcPipelines) UpdateStatus(drcPipeline *v1alpha1.DrcPipeline) (*v1alpha1.DrcPipeline, error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateSubresourceAction(drcpipelinesResource, "status", c.ns, drcPipeline), &v1alpha1.DrcPipeline{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.DrcPipeline), err
}

// Delete takes name of the drcPipeline and deletes it. Returns an error if one occurs.
func (c *FakeDrcPipelines) Delete(name string, options *v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteAction(drcpipelinesResource, c.ns, name), &v1alpha1.DrcPipeline{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeDrcPipelines) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(drcpipelinesResource, c.ns, listOptions)

	_, err := c.Fake.Invokes(action, &v1alpha1.DrcPipelineList{})
	return err
}

// Patch applies the patch and returns the patched drcPipeline.
func (c *FakeDrcPipelines) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1alpha1.DrcPipeline, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(drcpipelinesResource, c.ns, name, data, subresources...), &v1alpha1.DrcPipeline{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.DrcPipeline), err
}
