/*
Copyright The Kubernetes Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by informer-gen. DO NOT EDIT.

package v1alpha1

import (
	time "time"

	pipeline_v1alpha1 "github.com/moiot/gravity/k8s_operator/pkg/apis/pipeline/v1alpha1"
	versioned "github.com/moiot/gravity/k8s_operator/pkg/client/pipeline/clientset/versioned"
	internalinterfaces "github.com/moiot/gravity/k8s_operator/pkg/client/pipeline/informers/externalversions/internalinterfaces"
	v1alpha1 "github.com/moiot/gravity/k8s_operator/pkg/client/pipeline/listers/pipeline/v1alpha1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	runtime "k8s.io/apimachinery/pkg/runtime"
	watch "k8s.io/apimachinery/pkg/watch"
	cache "k8s.io/client-go/tools/cache"
)

// DrcPipelineInformer provides access to a shared informer and lister for
// DrcPipelines.
type DrcPipelineInformer interface {
	Informer() cache.SharedIndexInformer
	Lister() v1alpha1.DrcPipelineLister
}

type drcPipelineInformer struct {
	factory          internalinterfaces.SharedInformerFactory
	tweakListOptions internalinterfaces.TweakListOptionsFunc
	namespace        string
}

// NewDrcPipelineInformer constructs a new informer for DrcPipeline type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewDrcPipelineInformer(client versioned.Interface, namespace string, resyncPeriod time.Duration, indexers cache.Indexers) cache.SharedIndexInformer {
	return NewFilteredDrcPipelineInformer(client, namespace, resyncPeriod, indexers, nil)
}

// NewFilteredDrcPipelineInformer constructs a new informer for DrcPipeline type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewFilteredDrcPipelineInformer(client versioned.Interface, namespace string, resyncPeriod time.Duration, indexers cache.Indexers, tweakListOptions internalinterfaces.TweakListOptionsFunc) cache.SharedIndexInformer {
	return cache.NewSharedIndexInformer(
		&cache.ListWatch{
			ListFunc: func(options v1.ListOptions) (runtime.Object, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.DrcV1alpha1().DrcPipelines(namespace).List(options)
			},
			WatchFunc: func(options v1.ListOptions) (watch.Interface, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.DrcV1alpha1().DrcPipelines(namespace).Watch(options)
			},
		},
		&pipeline_v1alpha1.DrcPipeline{},
		resyncPeriod,
		indexers,
	)
}

func (f *drcPipelineInformer) defaultInformer(client versioned.Interface, resyncPeriod time.Duration) cache.SharedIndexInformer {
	return NewFilteredDrcPipelineInformer(client, f.namespace, resyncPeriod, cache.Indexers{cache.NamespaceIndex: cache.MetaNamespaceIndexFunc}, f.tweakListOptions)
}

func (f *drcPipelineInformer) Informer() cache.SharedIndexInformer {
	return f.factory.InformerFor(&pipeline_v1alpha1.DrcPipeline{}, f.defaultInformer)
}

func (f *drcPipelineInformer) Lister() v1alpha1.DrcPipelineLister {
	return v1alpha1.NewDrcPipelineLister(f.Informer().GetIndexer())
}
